package de.fhwi.codecover;

import junit.framework.TestCase;


public class TestJunit extends TestCase{
	
	WahrFalsch objWF;
	Fakultaet objF;
	Fibonacci objFib;
	
	/*Erzeugt Objekte der zu testenden Klassen*/
	protected void setUp() throws Exception {
		super.setUp();
		objWF = new WahrFalsch();
		objF = new Fakultaet();
		objFib = new Fibonacci();
	}
	
	protected void tearDown() throws Exception {
		super.tearDown();
	}
	
	// Testet ob beide Variablen wahr sind
	public void testWahrFalsch1(){
		String expected = "beide wahr";
		
		try{
			objWF.TestBeideWahr(true, true);
		}catch (Exception e) {
			fail("TestWahrFalsch1 fehlgeschlagen");
			e.printStackTrace();
		}
		
		assertEquals(expected, objWF.getString());
	}
	// testet ob Variablen nicht gleich sind, faengt erzeugte Exception
	public void testWahrFalsch2(){
		String expected = "nicht beide wahr";
		
		try{
			objWF.TestBeideWahr(false, true);
			fail();		// faengt die Exception
		}catch (Exception e) {
			assertEquals(expected, objWF.getString());
			//e.printStackTrace();		// auskommentiert, da ansonsten der gesamte Stacktrace 
										// auf der Konsole ausgegeben wird, wird schnell unuebersichtlich
			System.out.println("Variablen sind nicht gleich! Exception getestet");
		}		
	}
	
	
	public void testWahrFalsch3(){
		String expected = "a oder b wahr";
		
		try{
			objWF.TestOder(false, true);
		}catch (Exception e) {
			fail("TestWahrFalsch3 fehlgeschlagen");
			e.printStackTrace();
		}
		
		assertEquals(expected, objWF.getString());
		
	}
	
	public void testWahrFalsch4(){
		String expected = "keiner wahr";
		
		try{
			objWF.TestOder(false, false);
			fail();
		}catch (Exception e) {
			assertEquals(expected, objWF.getString());
			//e.printStackTrace();
			System.out.println("Keine Variable Wahr. Exception getestet");
		}	
	}
	// ---------------------------------------------------------------------------
	
	// Test von einzelnen Variablen
	public void testFak(){
		int expected = 120;
		int actual = 0;
		
		try{
			actual = objF.rekursiv(5);
		}catch (Exception e) {
			fail("Falsches Ergebnis");
			e.printStackTrace();
		}
		assertEquals(expected, actual);		// vergleicht den erwarteten Wert mit dem berechnetem Wert
		
	}
	
	// Test von Feldern
	
	public void testFib(){
		int[] expected = {0,1,1,2,3,5};
		int[] actual = {0,0,0,0,0,0};
		try {
			actual = objFib.iterativ(6);
		} catch (Exception e) {
			fail();
			e.printStackTrace();
		}
		for(int i=0;i<=5;i++){
			assertEquals(expected[i], actual[i]);
		}
		
		
	}
}

